// logger
// Copyright (C)2003 GORRY.

#include "g_inc.h"
#include "resource.h"
#include "frpoi.h"
#include "log.h"
#define SLEN 256

// =====================================================================
//  global
// =====================================================================

int LOG_PutLog;
HWND HWND_PutLog;
TCHAR LOG_LogPathName[MAX_PATH+100];

// =====================================================================
//  static
// =====================================================================

static CRITICAL_SECTION cs;

// =====================================================================
//  static֐
// =====================================================================

// =====================================================================
//  Õ[e[g
// =====================================================================

int LOG_Rotate(
	DWORD rotatesize
) {
	TCHAR rotatepathname[MAX_PATH+100];
	HANDLE hfile;
	DWORD filesize;

	hfile = CreateFile(
	  LOG_LogPathName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING,
	  FILE_ATTRIBUTE_NORMAL, NULL
	);
	if ( hfile == INVALID_HANDLE_VALUE ) {
		return (-1);
	}
	filesize = GetFileSize( hfile, NULL );
	CloseHandle( hfile );
	if ( filesize < rotatesize ) {
		return (0);
	}

	wsprintf( rotatepathname, TEXT("%s.2"), LOG_LogPathName );
	CopyFile( LOG_LogPathName, rotatepathname, FALSE );
	hfile = CreateFile(
	  LOG_LogPathName, GENERIC_WRITE, 0, NULL, TRUNCATE_EXISTING,
	  FILE_ATTRIBUTE_NORMAL, NULL
	);
	CloseHandle( hfile );
	LOG_Put( TEXT("-------- Rotate to %s --------\n"), rotatepathname );

	return (1);
}

// =====================================================================
//  Ot@C쐬
// =====================================================================

int LOG_MakeLogFileName(
	void
) {
	TCHAR modulename[MAX_PATH+1];

	if ( LOG_LogPathName[0] == '\0' ) {
		GetModuleFileName( NULL, modulename, sizeof(modulename) );
		wsprintf( LOG_LogPathName, TEXT("%s.log"), modulename );
	}

	return (0);
}

// =====================================================================
//  O{
// =====================================================================

int LOG_View(
	HWND hwnd
) {
	TCHAR editorpath[MAX_PATH];
	TCHAR execpath[MAX_PATH*3];
	HKEY hkey;
	DWORD type;
	DWORD len;
	int ret;
	HINSTANCE hinst;
	TCHAR *p;
	TCHAR msg[SLEN];

	LOG_MakeLogFileName();

	editorpath[0] = '\0';
	ret = RegOpenKeyEx(
	  HKEY_CLASSES_ROOT,
	  TEXT("\\txtfile\\shell\\open\\command"),
	  0, KEY_ALL_ACCESS, &hkey
	);
	if ( ret == ERROR_SUCCESS ) {
		len = MAX_PATH;
		RegQueryValueEx( hkey, NULL, 0, &type, (unsigned char *)&editorpath[0], &len );
		RegCloseKey( hkey );
	}
	if ( editorpath[0] == '\0' ) {
		hinst = 0;
	} else {
		p = _tcsstr( editorpath, TEXT("%1") );
		if ( p ) {
			p[0] = '\0';
			wsprintf( execpath, TEXT("%s%s%s"), editorpath, LOG_LogPathName, p+2 );
		} else {
			wsprintf( execpath, TEXT("%s \"%s\""), editorpath, LOG_LogPathName );
		}
#if 0
		ret = WinExec( cmdline, SW_SHOWNORMAL );
		if ( ret > 32 ) {
			return (0);
		}
#else
		hinst = ShellExecute( hwnd, NULL, execpath, LOG_LogPathName, NULL, SW_SHOWNORMAL );
		if ( (DWORD)hinst > 32 ) {
			return (0);
		}
#endif
	}
	wsprintf( editorpath, TEXT("notepad.exe") );
	hinst = ShellExecute( hwnd, NULL, editorpath, LOG_LogPathName, NULL, SW_SHOWNORMAL );
	if ( (DWORD)hinst <= 32 ) {
		LoadString( ThisInst, IDS_ERR_LOGPATHNAME, msg, sizeof(msg) );
		wsprintf( execpath, msg, LOG_LogPathName );
		MessageBox( hwnd, execpath, AppTitle, MB_OK|MB_ICONEXCLAMATION );
		return (-1);
	}

	return (0);
}

// =====================================================================
//  OJn
// =====================================================================

int LOG_Start(
	void
) {
	InitializeCriticalSection(&cs);

	LOG_Put_S( TEXT("-------- Log Start --------\n") );

	return (0);
}

// =====================================================================
//  OI
// =====================================================================

int LOG_End(
	void
) {
	LOG_Put_S( TEXT("-------- Log End --------\n") );
	return (0);
}

// =====================================================================
//  OSo[W̃Oo
// =====================================================================

int LOG_OSVersion(
	void
) {
	OSVERSIONINFOEX osvi = {0};
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
	GetVersionEx((LPOSVERSIONINFO)&osvi);
	LOG_Put_I3(TEXT("OS Version: %d.%d.%d\n"), osvi.dwMajorVersion, osvi.dwMinorVersion, osvi.dwBuildNumber);
	LOG_Put_I1(TEXT("OS Platform ID: %d\n"), osvi.dwPlatformId);
	LOG_Put_S1(TEXT("OS CSDVersion: %s\n"), osvi.szCSDVersion);
	LOG_Put_I2(TEXT("OS ServicePack: %d.%d\n"), osvi.wServicePackMajor, osvi.wServicePackMinor);
	LOG_Put_I1(TEXT("OS SuiteMask: %04x\n"), osvi.wSuiteMask);
	LOG_Put_I1(TEXT("OS ProductType: %02x\n"), osvi.wProductType);

	return (0);
}

// =====================================================================
//  Oo
// =====================================================================

int LOG_Put(
	TCHAR *format,
	TCHAR *str
) {
	FILE *fout;
	SYSTEMTIME st;
	TCHAR buf[32768+1024];

	EnterCriticalSection(&cs);

	GetLocalTime( &st );

	if ( LOG_PutLog ) {
		if ( HWND_PutLog ) {
			wsprintf( buf, TEXT("%04d/%02d/%02d %02d:%02d:%02d : "), st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond );
			SendMessage( HWND_PutLog, WM_APP_LOGMSG, 0, (LPARAM)buf );
			wsprintf( buf, format, str );
			SendMessage( HWND_PutLog, WM_APP_LOGMSG, 0, (LPARAM)buf );
		} else {
			LOG_MakeLogFileName();
#if defined(_UNICODE)
			fout = _tfopen( LOG_LogPathName, TEXT("a+, ccs=UTF-8") );
#else  // defined(_UNICODE)
			fout = _tfopen( LOG_LogPathName, TEXT("a+") );
#endif  // defined(_UNICODE)
			if ( fout ) {
				_ftprintf( fout, TEXT("%04d/%02d/%02d %02d:%02d:%02d : "), st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond );
				_ftprintf( fout, format, str );
				fclose( fout );
			}
		}
	}

	LeaveCriticalSection(&cs);

	return (0);
}

int LOG_Put_I1(
	TCHAR *format,
	int i1
) {
	TCHAR str[SLEN*2];

	wsprintf( str, format, i1 );
	LOG_Put( TEXT("%s"), str );
	return (0);
}

int LOG_Put_I2(
	TCHAR *format,
	int i1,
	int i2
) {
	TCHAR str[SLEN*2];

	wsprintf( str, format, i1, i2 );
	LOG_Put( TEXT("%s"), str );
	return (0);
}

int LOG_Put_I3(
	TCHAR *format,
	int i1,
	int i2,
	int i3
) {
	TCHAR str[SLEN*2];

	wsprintf( str, format, i1, i2, i3 );
	LOG_Put( TEXT("%s"), str );
	return (0);
}

int LOG_Put_S1I1(
	TCHAR *format,
	TCHAR *s1,
	int i1
) {
	TCHAR str[SLEN*2];

	wsprintf( str, format, s1, i1 );
	LOG_Put( TEXT("%s"), str );
	return (0);
}

int LOG_Put_S2(
	TCHAR *format,
	TCHAR *s1,
	TCHAR *s2
) {
	TCHAR str[SLEN*2];

	wsprintf( str, format, s1, s2 );
	LOG_Put( TEXT("%s"), str );
	return (0);
}

int LOG_Put_S3(
	TCHAR *format,
	TCHAR *s1,
	TCHAR *s2,
	TCHAR *s3
) {
	TCHAR str[SLEN*2];

	wsprintf( str, format, s1, s2, s3 );
	LOG_Put( TEXT("%s"), str );
	return (0);
}

// [EOF]
