// option_folder: folder option
// Copyright (C) 2004 GORRY.

#include "g_inc.h"
#include "frpoi.h"
#include "option_folder.h"

////////////////////////////////////////////////////////////////
// tH_IvVlݒ

int Option_Folder_Init(
	OPTION_FOLDER *of
) {
	memset( of, 0, sizeof(OPTION_FOLDER) );
	of->Stop = 1;
	of->FreeSpaceSize = 10000;
	of->Interval = 60;
	of->LogRotateSize = 100000;
	lstrcpy( of->TargetFolder, TEXT("C:\\record") );
	lstrcpy( of->TargetExt, TEXT("mpeg,m2p,mpg,m2v,m1v,m1p,mpa,mp2,wav") );

	return (0);
}

////////////////////////////////////////////////////////////////
// tH_IvṼpX쐬

int Option_Folder_GetPath(
	TCHAR *path
) {
	TCHAR modulepath[MAX_PATH+1];

	GetModuleFileName( NULL, modulepath, MAX_PATH );
	g_MakeFileName( modulepath, modulepath, TEXT("*.ini"), path, g_MAKEFILENAME_MODE_FORCE );

	return (0);
}

////////////////////////////////////////////////////////////////
// tH_IvVǂݍ

int Option_Folder_Load(
	OPTION_FOLDER *of,
	TCHAR *filename
) {
	OPTION_FOLDER def;

	Option_Folder_Init( &def );

	of->Stop          = GetPrivateProfileInt( TEXT("Folder"), TEXT("Stop")         , def.Stop         , filename );
	of->FindSubFolder = GetPrivateProfileInt( TEXT("Folder"), TEXT("FindSubFolder"), def.FindSubFolder, filename );
	of->DelSubFolder  = GetPrivateProfileInt( TEXT("Folder"), TEXT("DelSubFolder") , def.DelSubFolder , filename );
	of->FreeSpaceSize = GetPrivateProfileInt( TEXT("Folder"), TEXT("FreeSpaceSize"), def.FreeSpaceSize, filename );
	of->Interval      = GetPrivateProfileInt( TEXT("Folder"), TEXT("Interval")     , def.Interval     , filename );
	of->CompareTime   = GetPrivateProfileInt( TEXT("Folder"), TEXT("CompareTime")  , def.CompareTime  , filename );
	of->ToTrashCan    = GetPrivateProfileInt( TEXT("Folder"), TEXT("ToTrashCan")   , def.ToTrashCan   , filename );
	of->DelReadOnly   = GetPrivateProfileInt( TEXT("Folder"), TEXT("DelReadOnly")  , def.DelReadOnly  , filename );
	of->DelHidden     = GetPrivateProfileInt( TEXT("Folder"), TEXT("DelHidden")    , def.DelHidden    , filename );
	of->VerboseLog    = GetPrivateProfileInt( TEXT("Folder"), TEXT("VerboseLog")   , def.VerboseLog   , filename );
	of->LogRotateSize = GetPrivateProfileInt( TEXT("Folder"), TEXT("LogRotateSize"), def.LogRotateSize, filename );

	GetPrivateProfileString( TEXT("Folder"), TEXT("TargetFolder"), def.TargetFolder, of->TargetFolder, MAX_PATH, filename );
	GetPrivateProfileString( TEXT("Folder"), TEXT("TargetExt"), def.TargetExt, of->TargetExt, MAX_PATH, filename );

	if ( of->TargetFolder[lstrlen( of->TargetFolder )-1] != '\\' ) {
		lstrcat( of->TargetFolder, TEXT("\\") );
	}

	return (0);
}

////////////////////////////////////////////////////////////////
// tH_IvVۑ

int Option_Folder_Save(
	OPTION_FOLDER *of,
	TCHAR *filename
) {
	TCHAR str[SLEN];

#if defined(_UNICODE)
	{
		// BOMĂUTF-16ŏ
		FILE *fout = _tfopen( filename, TEXT("wb") );
		fputc(0xff, fout);
		fputc(0xfe, fout);
		fclose(fout);
	}
#else  // defined(_UNICODE)
	{
		// truncateĂ
		FILE *fout = _tfopen( filename, TEXT("wb") );
		fclose(fout);
	}
#endif  // defined(_UNICODE)

	wsprintf( str, TEXT("%d"), of->Stop );
	if ( !WritePrivateProfileString( TEXT("Folder"), TEXT("Stop"), str, filename ) ) goto err;

	wsprintf( str, TEXT("%d"), of->FindSubFolder );
	if ( !WritePrivateProfileString( TEXT("Folder"), TEXT("FindSubFolder"), str, filename ) ) goto err;

	wsprintf( str, TEXT("%d"), of->DelSubFolder );
	if ( !WritePrivateProfileString( TEXT("Folder"), TEXT("DelSubFolder"), str, filename ) ) goto err;

	wsprintf( str, TEXT("%d"), of->FreeSpaceSize );
	if ( !WritePrivateProfileString( TEXT("Folder"), TEXT("FreeSpaceSize"), str, filename ) ) goto err;

	wsprintf( str, TEXT("%d"), of->Interval );
	if ( !WritePrivateProfileString( TEXT("Folder"), TEXT("Interval"), str, filename ) ) goto err;

	wsprintf( str, TEXT("%d"), of->CompareTime );
	if ( !WritePrivateProfileString( TEXT("Folder"), TEXT("CompareTime"), str, filename ) ) goto err;

	wsprintf( str, TEXT("%d"), of->ToTrashCan );
	if ( !WritePrivateProfileString( TEXT("Folder"), TEXT("ToTrashCan"), str, filename ) ) goto err;

	wsprintf( str, TEXT("%d"), of->DelReadOnly );
	if ( !WritePrivateProfileString( TEXT("Folder"), TEXT("DelReadOnly"), str, filename ) ) goto err;
	
	wsprintf( str, TEXT("%d"), of->DelHidden );
	if ( !WritePrivateProfileString( TEXT("Folder"), TEXT("DelHidden"), str, filename ) ) goto err;

	wsprintf( str, TEXT("%d"), of->VerboseLog );
	if ( !WritePrivateProfileString( TEXT("Folder"), TEXT("VerboseLog"), str, filename ) ) goto err;

	wsprintf( str, TEXT("%d"), of->LogRotateSize );
	if ( !WritePrivateProfileString( TEXT("Folder"), TEXT("LogRotateSize"), str, filename ) ) goto err;

	if ( !WritePrivateProfileString( TEXT("Folder"), TEXT("TargetFolder"), of->TargetFolder, filename ) ) goto err;

	if ( !WritePrivateProfileString( TEXT("Folder"), TEXT("TargetExt"), of->TargetExt, filename ) ) goto err;
	{
		TCHAR *p1, *p2;
		TCHAR c;
		p1 = of->TargetExt;
		p2 = of->TargetExt;
		while (!0) {
			c = *(p1++);
			if ( c == '\0' ) break;
			if ( c != ' ' ) {
				*(p2++) = c;
			}
		}
		*(p2) = '\0';
	}

	return (0);

  err:;
	return (-1);
}


////////////////////////////////////////////////////////////////
// [EOF]
