// wp_main: main window
// Copyright (C) 2004 GORRY.

#include "wp_main.h"
#include "wp_folder.h"
#include "wp_about.h"

OPTION_FOLDER Option;

static HWND MY_HWND;
static HMENU MY_TIMN_Parent;
static HMENU MY_TIMN;
static int DisableTrayIconCmd;
static int TIMER_Delete;
static int Main_Poi_Busy;
static CRITICAL_SECTION CSec;

////////////////////////////////////////////////////////////////
// Jn

int WP_Main_Startup(
	void
) {
	return (0);
}

////////////////////////////////////////////////////////////////
// EBhE쐬

#define ONLYONE 1  // !0Ŕr

HWND WP_Main_Create(
	HWND hwndparent,
	int nWinMode
) {
	WNDCLASS wc;
	TCHAR windowname[SLEN+1];
	TCHAR classname[SLEN+1];
	TCHAR friendname[SLEN+1];
	HWND hwnd;
	TCHAR modulepath[MAX_PATH];
	TCHAR dir[MAX_PATH];
	TCHAR base[MAX_PATH];
	TCHAR ext[MAX_PATH];

	GetModuleFileName( NULL, modulepath, MAX_PATH );
	g_ParseFileName( modulepath, dir, base, ext );
	wsprintf( classname, TEXT("%s_class"), base );

	LoadString( ThisInst, IDS_WINDOWNAME, windowname, sizeof(windowname) );
//	LoadString( ThisInst, IDS_CLASSNAME, classname, sizeof(classname) );
	LoadString( ThisInst, IDS_FRIENDNAME, friendname, sizeof(friendname) );

#if ONLYONE
	{
		HANDLE hfriend;
		int reqquit;

		hwnd = FindWindow( classname, windowname );
		if ( hwnd ) {
			reqquit = FALSE;
			hfriend = CreateFileMapping( (HANDLE)0xffffffff, NULL, PAGE_READWRITE, 0, 1024, friendname );
			if ( hfriend ) {
				void *p = MapViewOfFile( hfriend, FILE_MAP_READ|FILE_MAP_WRITE, 0, 0, 0 );
				if ( p ) {
					*((TCHAR *)(p)) = '\0';
					SendMessage( hwnd, WM_USER_MAIN_FINDFRIEND, 0, 0 );
					if ( lstrcmp( (TCHAR *)p, friendname ) ) {
						reqquit = TRUE;
					}
					UnmapViewOfFile( p );
				}
				CloseHandle( hfriend );
			}
			if ( reqquit ) {
				SendMessage( hwnd, WM_COMMAND, WM_USER_MAIN_START, 0 );
			}
			return (NULL);
		}
	}
#endif

	ZeroMemory( &wc, sizeof(wc) );
	wc.hInstance = ThisInst;
	wc.lpszClassName = classname;
	wc.lpfnWndProc = WP_Main_Proc;
	wc.style = 0;
	wc.hIcon = LoadIcon( NULL, MAKEINTRESOURCE(IDI_ICON1) );
//	wc.hCursor = LoadCursor( NULL, IDC_ARROW );
//	wc.lpszMenuName = menuname;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hbrBackground = (HBRUSH)GetStockObject( WHITE_BRUSH );
	if ( !RegisterClass( &wc ) ) {
		return (FALSE);
	}

	hwnd = CreateWindow(
	  classname,
	  windowname,
	  WS_OVERLAPPEDWINDOW|WS_DISABLED,
	  0,
	  0,
	  GetSystemMetrics( SM_CXSCREEN ),
	  GetSystemMetrics( SM_CYSCREEN ),
	  NULL,
	  NULL,
	  ThisInst,
	  NULL
	);

	return (hwnd);
}

////////////////////////////////////////////////////////////////
// I

void WP_Main_End(
	void
) {
}

////////////////////////////////////////////////////////////////
// ^XNACRݒ

static int SetTaskIcon(
	int iconid,
	int md
) {
	TCHAR str[MAX_PATH+256];

	wsprintf( str, TEXT("%s - %s"), Option.TargetFolder, AppTitle );
	g_SetTaskIconMessage( str );
	g_SetTaskIconID( iconid );
	g_SetTaskIcon( ThisInst, MY_HWND, IDB_TASKICON, WM_USER_MAIN_NOTIFYICON, md );

	return (0);
}

////////////////////////////////////////////////////////////////
// 

static int MY_INIT(
	void
) {
	return (0);
}

////////////////////////////////////////////////////////////////
// ǂݍ

static int MY_LOAD(
	void
) {
	return (0);
}

////////////////////////////////////////////////////////////////
// ۑ

static int MY_SAVE(
	void
) {
	return (0);
}

////////////////////////////////////////////////////////////////
// |bvAbvj[\

static BOOL DisplayPopupMenu(
	void
) {
	POINT p;

	// j[\
	SetForegroundWindow( MY_HWND );
	GetCursorPos( &p );
	if ( !MY_TIMN ) {
		MY_TIMN_Parent = LoadMenu( ThisInst, MAKEINTRESOURCE(IDR_POPUP_TASKICON) );
		MY_TIMN = GetSubMenu( MY_TIMN_Parent, 0 );
	}

	CheckMenuItem(MY_TIMN, IDM_POPUP_TASKICON_STOP, Option.Stop ? MF_CHECKED : MF_UNCHECKED );

	TrackPopupMenu( MY_TIMN, TPM_LEFTALIGN|TPM_RIGHTBUTTON, p.x, p.y, 0, MY_HWND, NULL );

	return (0);
}

////////////////////////////////////////////////////////////////
// |bvAbvj[j

static BOOL DestroyPopupMenu(
	void
) {
	if ( MY_TIMN ) {
		DestroyMenu( MY_TIMN_Parent );
		MY_TIMN = NULL;
	}

	return (0);
}

////////////////////////////////////////////////////////////////
// CvV[W

LRESULT CALLBACK WP_Main_Proc(
	HWND hwnd,
	UINT message,
	WPARAM wParam,
	LPARAM lParam
) {
	WPParam wp;
	int ret;
	TCHAR path[MAX_PATH+1];

	wp.hwnd = hwnd;
	wp.message = message;
	wp.wParam = wParam;
	wp.lParam = lParam;

	switch ( message ) {
	  case WM_CREATE:
		// EBhE쐬
		MY_HWND = hwnd;
		ThisHWND = hwnd;
		InitializeCriticalSection( &CSec );
		MY_INIT();
		Option_Folder_GetPath( path );
		Option_Folder_Init( &Option );
		Option_Folder_Load( &Option, path );
		SetTaskIcon( 0, 1 );
		SendMessage( hwnd, WM_USER_MAIN_DELETE, 0, 0 );
		break;

	  case WM_ENDSESSION:
		// AvI
		return (0);

	  case WM_USER_MAIN_ENDPOI:
		Main_Poi_Busy = 0;
		SetTaskIcon( 0, 1 );
		break;

	  case WM_TIMER:
		// ^C}[
#if 1
		switch ( wParam ) {
		  case TIMERID_DELETE:
			SendMessage( hwnd, WM_USER_MAIN_DELETE, 0, 0 );
			break;
		}
#endif
		break;

	  case WM_USER_MAIN_DELETE:
		// 폜
		EnterCriticalSection( &CSec );
		if ( Main_Poi_Busy ) {
			LeaveCriticalSection( &CSec );
			break;
		}
		Main_Poi_Busy = 1;
		LeaveCriticalSection( &CSec );
		SetTaskIcon( 3, 1 );
		if (!TIMER_Delete) {
			TIMER_Delete = SetTimer( hwnd, TIMERID_DELETE, Option.Interval*1000*60, 0 );
		}
		LOG_Rotate( Option.LogRotateSize );
		Fork_Poi_Main( &Option, 0, hwnd );
		Main_Poi_Busy = 0;
		break;

	  case WM_USER_MAIN_START:
		// Q߂̃vZXN
		SetForegroundWindow( g_FindChildWindow( MY_HWND ) );
		return (0);

	  case WM_USER_MAIN_FINDFRIEND:
		// FBvZX݊mF
		{
			TCHAR friendname[SLEN+1];
			HANDLE hfriend;
			LoadString( ThisInst, IDS_FRIENDNAME, friendname, sizeof(friendname) );
			hfriend = OpenFileMapping( FILE_MAP_READ|FILE_MAP_WRITE, FALSE, friendname );
			if ( hfriend ) {
				void *p = MapViewOfFile( hfriend, FILE_MAP_READ|FILE_MAP_WRITE, 0, 0, 0 );
				if ( p ) {
					lstrcpy( (LPTSTR)p, friendname );
				}
			}
			CloseHandle( hfriend );
		}
		return (0);

	  case WM_COMMAND:
		switch (GET_WM_COMMAND_ID(wParam, lParam)) {
		  case IDM_POPUP_TASKICON_ABOUT:
			DisableTrayIconCmd = 1;
			Main_Poi_Busy = 1;
			WP_About_Dialog( hwnd );
			Main_Poi_Busy = 0;
			DisableTrayIconCmd = 0;
			return (TRUE);

		  case IDM_POPUP_TASKICON_SETUP:
			// ݒ
			if ( Main_Poi_Busy ) {
				// "Ď̂߁Aݒ͂ł܂B"
				g_MyMessageBox( ThisInst, hwnd, IDS_WINDOWNAME, IDS_MSG_TASKICONBUSY, MB_ICONINFORMATION|MB_OK );
				break;
			}
			KillTimer( hwnd, TIMERID_DELETE );
			TIMER_Delete = 0;
			DisableTrayIconCmd = 1;
			Main_Poi_Busy = 1;
			SetTaskIcon( 2, 1 );
			ret = WP_Folder_Dialog( hwnd );
			if ( ret )
			{
				Option_Folder_GetPath( path );
				Option_Folder_Save( &Option, path );
			}
			Main_Poi_Busy = 0;
			DisableTrayIconCmd = 0;
			SetTaskIcon( 0, 1 );
			SendMessage( hwnd, WM_USER_MAIN_DELETE, 0, 0 );
			return (TRUE);

		  case IDM_POPUP_TASKICON_QUIT:
			// I
			KillTimer( hwnd, TIMERID_DELETE );
			TIMER_Delete = 0;
			DestroyWindow( MY_HWND );
			return (TRUE);

		  case IDM_POPUP_TASKICON_VIEWLOG:
			// O{
			LOG_View( hwnd );
			return (TRUE);

		  case IDM_POPUP_TASKICON_STOP:
			// Ď~/ĊJ
			Option.Stop = !Option.Stop;
			if ( Option.Stop == 0 ) {
				SendMessage( hwnd, WM_USER_MAIN_DELETE, 0, 0 );
			}
			return (TRUE);

		}
		break;

	  case WM_DESTROY:
		// EBhEE
		KillTimer( hwnd, TIMERID_DELETE );
		TIMER_Delete = 0;
		while ( Main_Poi_Busy ) {
			Sleep( 1000 );
		}
		SetTaskIcon( 0, 0 );
		DestroyPopupMenu();
		MY_HWND = NULL;
		Option_Folder_GetPath( path );
		Option_Folder_Save( &Option, path );
		PostQuitMessage(0);
		return (0);

	  default:
		// gCACR
		if ( message == WM_USER_MAIN_NOTIFYICON ) {
			switch (lParam) {
			  case WM_LBUTTONDOWN:
				// NbN
				// through
			  case WM_RBUTTONDOWN:
				// ENbN
				if ( DisableTrayIconCmd ) {
					// j[֎~̓tHAOEh擾
					SetForegroundWindow( g_FindChildWindow( MY_HWND ) );
					return (0);
				}
				// j[\
				DisplayPopupMenu();
				return (0);
			}
			return (TRUE);
		}

	}
	return ( DefWindowProc( hwnd, message, wParam, lParam ) );
}


////////////////////////////////////////////////////////////////
// [EOF]
